Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Unbounded_Set Class Template Reference

Implement a simple unordered set of <T> of unbounded size. More...

`#include <Unbounded_Set.h>`

Collaboration diagram for ACE_Unbounded_Set:

[legend]
List of all members.

## Public Types
typedef ACE_Unbounded_Set_Iterator< T> | ITERATOR
typedef ACE_Unbounded_Set_Iterator< T> | iterator
typedef ACE_Unbounded_Set_Const_Iterator< T> | CONST_ITERATOR
typedef ACE_Unbounded_Set_Const_Iterator< T> | const_iterator
## Public Methods
| ACE_Unbounded_Set (ACE_Allocator *alloc = 0)
| Constructor. Use user specified allocation strategy if specified.
| ACE_Unbounded_Set (const ACE_Unbounded_Set<T> &)
| Copy constructor.
void | operator= (const ACE_Unbounded_Set<T> &)
| Assignment operator.
| ~ACE_Unbounded_Set (void)
| Destructor.
int | is_empty (void) const
| Returns 1 if the container is empty, otherwise returns 0.
int | is_full (void) const
| Returns 1 if the container is full, otherwise returns 0.
int | insert (const T &new_item)
int | remove (const T &item)
int | find (const T &item) const
| Finds if <item> occurs in the set. Returns 0 if find succeeds, else -1.
size_t | size (void) const
| Size of the set.
void | dump (void) const
| Dump the state of an object.
void | reset (void)
| Reset the to be empty.
ACE_Unbounded_Set_Iterator<T> | begin (void)
ACE_Unbounded_Set_Iterator<T> | end (void)
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks.
## Private Methods
int | insert_tail (const T &item)
| Insert <item> at the tail of the set (doesn't check for duplicates).
void | delete_nodes (void)
| Delete all the nodes in the Set.
void | copy_nodes (const ACE_Unbounded_Set<T> &)
| Copy nodes into this set.
## Private Attributes
ACE_Node<T>* | head_
| Head of the linked list of Nodes.
size_t | cur_size_
| Current size of the set.
ACE_Allocator* | allocator_
| Allocation strategy of the set.
## Friends
class | ACE_Unbounded_Set_Iterator< T >
class | ACE_Unbounded_Set_Const_Iterator< T >

## Detailed Description

### template<class T> template class ACE_Unbounded_Set

Implement a simple unordered set of <T> of unbounded size.

This implementation of an unordered set uses a circular linked list with a dummy node. This implementation does not allow duplicates, but it maintains FIFO ordering of insertions.

## Member Typedef Documentation

template<classT>
typedef ACE_Unbounded_Set_Const_Iterator<T> ACE_Unbounded_Set<T>::CONST_ITERATOR

template<classT>
typedef ACE_Unbounded_Set_Iterator<T> ACE_Unbounded_Set<T>::ITERATOR

template<classT>
typedef ACE_Unbounded_Set_Const_Iterator<T> ACE_Unbounded_Set<T>::const_iterator

template<classT>
typedef ACE_Unbounded_Set_Iterator<T> ACE_Unbounded_Set<T>::iterator

## Constructor & Destructor Documentation

template<classT>
ACE_Unbounded_Set<T>::ACE_Unbounded_Set<T> ( | ACE_Allocator * alloc = 0 )

| Constructor. Use user specified allocation strategy if specified.

template<classT>
ACE_Unbounded_Set<T>::ACE_Unbounded_Set<T> ( | const ACE_Unbounded_Set< T >& us )

| Copy constructor.

template<classT>
ACE_Unbounded_Set<T>::~ACE_Unbounded_Set<T> ( | void )

| Destructor.

## Member Function Documentation

template<classT>
ACE_Unbounded_Set_Iterator< T > ACE_Unbounded_Set< T >::begin ( | void )

template<classT>
void ACE_Unbounded_Set<T>::copy_nodes ( | const ACE_Unbounded_Set< T >& us )`[private]`

| Copy nodes into this set.

template<classT>
void ACE_Unbounded_Set<T>::delete_nodes ( | void )`[private]`

| Delete all the nodes in the Set.

template<classT>
void ACE_Unbounded_Set<T>::dump ( | void ) const

| Dump the state of an object.

template<classT>
ACE_Unbounded_Set_Iterator< T > ACE_Unbounded_Set< T >::end ( | void )

template<classT>
int ACE_Unbounded_Set<T>::find ( | const T & item ) const

| Finds if <item> occurs in the set. Returns 0 if find succeeds, else -1.

template<classT>
int ACE_Unbounded_Set<T>::insert ( | const T & new_item )

| Insert <new_item> into the set (doesn't allow duplicates). Returns -1 if failures occur, 1 if item is already present, else 0.

template<classT>
int ACE_Unbounded_Set<T>::insert_tail ( | const T & item )`[private]`

| Insert <item> at the tail of the set (doesn't check for duplicates).

template<classT>
ACE_INLINE int ACE_Unbounded_Set< T >::is_empty ( | void ) const

| Returns 1 if the container is empty, otherwise returns 0.

template<classT>
ACE_INLINE int ACE_Unbounded_Set< T >::is_full ( | void ) const

| Returns 1 if the container is full, otherwise returns 0.

template<classT>
void ACE_Unbounded_Set<T>::operator= ( | const ACE_Unbounded_Set< T >& us )

| Assignment operator.

template<classT>
int ACE_Unbounded_Set<T>::remove ( | const T & item )

| Remove first occurrence of <item> from the set. Returns 0 if it removes the item, -1 if it can't find the item, and -1 if a failure occurs.

template<classT>
void ACE_Unbounded_Set<T>::reset ( | void )

| Reset the to be empty.

template<classT>
size_t ACE_Unbounded_Set<T>::size ( | void ) const

| Size of the set.

## Friends And Related Function Documentation

template<classT>
class ACE_Unbounded_Set_Const_Iterator`[friend]`

template<classT>
class ACE_Unbounded_Set_Iterator`[friend]`

## Member Data Documentation

template<classT>
ACE_Unbounded_Set<T>::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks.

template<classT>
ACE_Allocator * ACE_Unbounded_Set<T>::allocator_`[private]`

| Allocation strategy of the set.

template<classT>
size_t ACE_Unbounded_Set<T>::cur_size_`[private]`

| Current size of the set.

template<classT>
ACE_Node< T >* ACE_Unbounded_Set<T>::head_`[private]`

| Head of the linked list of Nodes.

The documentation for this class was generated from the following files:

- Unbounded_Set.h
- Unbounded_Set.cpp
- Unbounded_Set.inl